
var machineUrl = '../export/machine/';
var machinegraphicUrl = machineUrl + 'archer.graphic.svg';
var machineconfigUrl = machineUrl + 'archer.config.json';
var machinecontainer = document.getElementById('machinegraphic');
var machinegraphic = archer.create(machinecontainer);


var fpm = 25;               // Images / sec
var updatrate = 1000/fpm;   //in milliseconds
var curinterval = 0;


// initial variable values
var foil = 5000000;     // in cm
var temp1 = 100;        // preheating
var speed = 4;          // feeding speed
var temp2 = 100;        // heating
var piecesperforming = 125;  // amount of pcs per forming
var formingspermeter = 0.5; // amount of formings per meter
var pieces = piecesperforming*formingspermeter*speed;     // Pieces per minute
var frequency = updatrate/(formingspermeter*speed);
var punch = false;
var level = 7.5;
var duration = 10;
var pressure = 9.6;
var efficiency = 98;
var rotators = 0;
var filllevel = 0;

var speedoffset = 0.1;
var tempoffset = 2;
var pressureoffset = 0.1;
var levelOffset = 0.5;





$(function(){
  machinegraphic.on('element.mouseup', function (domElement) {
    console.log(domElement.id); // true
    
    switch (domElement.id) {
      case "speed-up":
        speed = Math.min(10,Math.ceil((speed+speedoffset)*10)/10);
        machinegraphic.setValue('speed', speed);
        updateFrequency();
        break;
      case "speed-down":
        speed = Math.max(0,Math.floor((speed-speedoffset)*10)/10);
        machinegraphic.setValue('speed', speed);
        updateFrequency();
        break;
      case "temp1-up":
        temp1 = Math.min(120, temp1 + tempoffset);
        machinegraphic.setValue('temp1', temp1);
        break;
      case "temp1-down":
        temp1 = Math.max(80, temp1 - tempoffset);
        machinegraphic.setValue('temp1', temp1);
        break;
      case "temp2-up":
        temp2 = Math.min(120, temp2 + tempoffset);
        machinegraphic.setValue('temp2', temp2);
        break;
      case "temp2-down":
        temp2 = Math.max(80, temp2 - tempoffset);
        machinegraphic.setValue('temp2', temp2);
        break;
      case "pressure-up":
        pressure = Math.min(15, Math.round((pressure + pressureoffset)*10)/10);
        machinegraphic.setValue('pressure', pressure);
        break;
      case "pressure-down":
        pressure = Math.max(5, Math.round((pressure - pressureoffset)*10)/10);
        machinegraphic.setValue('pressure', pressure);
        break;
      case "level-up":
        level = Math.min(10, Math.round((level + levelOffset)*10)/10);
        machinegraphic.setValue('level', level);
        break;
      case "level-down":
        level = Math.max(1, Math.round((level - levelOffset)*10)/10);
        machinegraphic.setValue('level', level);
        break;


        machinegraphic.setValue('level', level);
    }
  });

  var machineupdateIV = setInterval(machineupdate, 40);
});


function machineupdate() {
  curinterval++;

  // Folie
  foil = (foil - (speed*100/updatrate));      //*100 wegen Umrechnung cm -> m
  foilString = Math.round(foil).toString();
  foildigits = foilString.substring(0,foilString.length-2);
  foiltenths = foilString.substr(foilString.length-2);
  foilString = foildigits + "." + foiltenths;
  machinegraphic.setValue('foil', foilString);
  if (foil < 1) foil = 5000000;


  // Achsen
  rotators = rotators + (speed/5);
  if (rotators >= 100) rotators = 0;
  machinegraphic.setValue('foilfeed', rotators);


  // Filling
  filllevel = filllevel+2;
  if (filllevel >= 100) filllevel = 0;
  machinegraphic.setValue('filllevel', filllevel);


  // Stempel
  if (curinterval >= frequency) {
    machinegraphic.setValue('punch', 0);
    var abortpunchTO = setTimeout(function(){machinegraphic.setValue('punch', 1);},250);
    curinterval = 0;
  }

  // Cutter
  if (curinterval == 5) {
    machinegraphic.setValue('cutter', 0);
    var abortcutTO = setTimeout(function(){machinegraphic.setValue('cutter', 1);},250);
  }
}


function updateFrequency() {
  pieces = Math.round(piecesperforming*formingspermeter*speed);
  frequency = Math.round(updatrate/(formingspermeter*speed));     // Alle x ms ein Stempelvorgang
  machinegraphic.setValue('frequency', pieces);
}


// Initialize archer
machinegraphic.loadUrl(machinegraphicUrl, machineconfigUrl);
machinegraphic.on('ready', function () {
  machinegraphic.view.zoomToFit(true);
  machinegraphic.view.enableMouse(false, false);
  machinegraphic.setValue('foil', foil);
  machinegraphic.setValue('temp1', temp1);
  machinegraphic.setValue('speed', speed);
  machinegraphic.setValue('temp2', temp2);
  machinegraphic.setValue('frequency', pieces);
  machinegraphic.setValue('level', level);
  machinegraphic.setValue('duration', duration);
  machinegraphic.setValue('pressure', pressure);
  machinegraphic.setValue('efficiency', efficiency);
  machinegraphic.setValue('punch', punch);
  machinegraphic.setValue('filllevel', filllevel);
  machinegraphic.setValue('foilfeed', rotators);
});
window.addEventListener('resize', function () {machinegraphic.view.resize();});





machinegraphic.on('error', function() {
    document.getElementById('error').style['display'] = 'block';
});



